apiVersion: {{ deployment_apivers }}
kind: {{ deployment_kind }}
metadata:
  labels:
{% if pki_set | length > 0 %}
    pki.opsperator.io/has-ca: {{ pki_set | join(',') }}
{% endif %}
    {{ network_policy_deployment_label }}: {{ zpush_name }}
  name: {{ zpush_name }}
  namespace: {{ namespace }}
spec:
  replicas: {{ zpush_replicas }}
  revisionHistoryLimit: {{ deploy_revision_history_limit | default(10) }}
  selector:
{% if deployment_kind != 'DeploymentConfig' %}
    matchLabels:
      name: {{ zpush_name }}
  strategy:
{% if zpush_db_type == 'file' %}
    type: Recreate
{% else %}
    type: RollingUpdate
{% endif %}
{% else %}
    name: {{ zpush_name }}
  strategy:
    resources:
      limits:
        cpu: {{ deploy_pod_cpu_limit }}
        memory: {{ deploy_pod_memory_limit }}
      requests:
        cpu: {{ deploy_pod_cpu_request }}
        memory: {{ deploy_pod_memory_request }}
{% if zpush_db_type == 'file' %}
    type: Recreate
{% else %}
    type: Rolling
{% endif %}
{% endif %}
  template:
    metadata:
      labels:
        name: {{ zpush_name }}
{% if pki_set | length > 0 %}
        pki.opsperator.io/has-ca: {{ pki_set | join(',') }}
{% endif %}
    spec:
{% if do_affinities %}
      affinity:
        podAntiAffinity:
{% if scheduling_affinity_required %}
          requiredDuringSchedulingIgnoredDuringExecution:
          - labelSelector:
              matchExpressions:
              - key: name
                operator: In
                values: [ {{ zpush_name }} ]
            topologyKey: {{ k8s_affinity_zone_label }}
{% else %}
          preferredDuringSchedulingIgnoredDuringExecution:
          - podAffinityTerm:
              labelSelector:
                matchExpressions:
                - key: name
                  operator: In
                  values: [ {{ zpush_name }} ]
              topologyKey: {{ k8s_affinity_zone_label }}
            weight: 42
{% endif %}
{% endif %}
      automountServiceAccountToken: false
      containers:
      - env:
        - name: APACHE_DOMAIN
          value: {{ zpush_fqdn }}
        - name: APACHE_HTTP_PORT
          value: "8080"
        - name: DEBUG
          value: "{% if do_debugs %}yay{% endif %}"
        - name: IMAP_HOST
{% if imaps_address | default(False) %}
          value: {{ imaps_address | urlsplit('hostname') }}
        - name: IMAP_PORT
          value: "{{ imaps_address | urlsplit('port') }}"
        - name: IMAP_PROTO
          value: {{ imaps_address | urlsplit('scheme') }}
{% else %}
          value: {{ imap_address | urlsplit('hostname') }}
        - name: IMAP_PORT
          value: "{{ imap_address | urlsplit('port') }}"
        - name: IMAP_PROTO
          value: {{ imap_address | urlsplit('scheme') }}
{% endif %}
        - name: MEMCACHED_HOST
{% if do_memcached %}
          value: "{% for n in range(memcached_replicas | default(3) | int) %} {{ memcached_name }}-{{ loop.index0 }}.{{ memcached_name }}.{{ namespace }}.svc.{{ cluster_domain }}:11211{% endfor %}"
{% else %}
          value: ""
{% endif %}
{% if zpush_db_type == 'percona' %}
        - name: MYSQL_DATABASE
          valueFrom:
            secretKeyRef:
              key: database-name
              name: {{ zpshpc_name }}
        - name: MYSQL_HOST
          value: {{ zpshpc_name }}-client
        - name: MYSQL_PASSWORD
          valueFrom:
            secretKeyRef:
              key: database-password
              name: {{ zpshpc_name }}
        - name: MYSQL_USER
          valueFrom:
            secretKeyRef:
              key: database-user
              name: {{ zpshpc_name }}
{% elif zpush_db_type in [ 'mariadb', 'mysql' ] %}
        - name: MYSQL_DATABASE
          valueFrom:
            secretKeyRef:
              key: database-name
              name: {{ zpshms_name }}
        - name: MYSQL_HOST
          value: {{ zpshms_name }}
        - name: MYSQL_PASSWORD
          valueFrom:
            secretKeyRef:
              key: database-password
              name: {{ zpshms_name }}
        - name: MYSQL_USER
          valueFrom:
            secretKeyRef:
              key: database-user
              name: {{ zpshms_name }}
{% else %}
        - name: MYSQL_PASSWORD
          value: ""
{% endif %}
{% if do_ldap %}
        - name: OPENLDAP_BASE
          valueFrom:
            secretKeyRef:
              key: directory-root
              name: {{ ldap_secret_name }}
        - name: OPENLDAP_BIND_DN_PREFIX
          value: cn=zpush,ou=services
        - name: OPENLDAP_BIND_PW
          valueFrom:
            secretKeyRef:
              key: zpush-password
              name: {{ ldap_secret_name }}
        - name: OPENLDAP_DOMAIN
          value: {{ root_domain }}
        - name: OPENLDAP_HOST
{% if ldaps_address | default(False) %}
          value: {{ ldaps_address | urlsplit('hostname') }}
        - name: OPENLDAP_PORT
          value: "{{ ldaps_address | urlsplit('port') }}"
        - name: OPENLDAP_PROTO
          value: ldaps
{% else %}
          value: {{ ldap_address | urlsplit('hostname') }}
        - name: OPENLDAP_PORT
          value: "{{ ldap_address | urlsplit('port') }}"
        - name: OPENLDAP_PROTO
          value: ldap
{% endif %}
{% else %}
        - name: OPENLDAP_BASE
          value: ""
        - name: OPENLDAP_BIND_DN_PREFIX
          value: ""
        - name: OPENLDAP_BIND_PW
          value: ""
        - name: OPENLDAP_DOMAIN
          value: ""
        - name: OPENLDAP_HOST
          value: ""
        - name: OPENLDAP_PORT
          value: ""
        - name: OPENLDAP_PROTO
          value: ""
{% endif %}
        - name: PHP_MAX_EXECUTION_TIME
          value: "{{ zpush_php_max_execution_time }}"
        - name: PHP_MEMORY_LIMIT
          value: {{ zpush_php_memory_limit }}
{% if zpush_db_type == 'postgres' %}
        - name: POSTGRES_DB
          valueFrom:
            secretKeyRef:
              key: database-name
              name: {{ zpshpg_name }}
        - name: POSTGRES_HOST
          value: {{ zpshpg_name }}
        - name: POSTGRES_PASSWORD
          valueFrom:
            secretKeyRef:
              key: database-password
              name: {{ zpshpg_name }}
        - name: POSTGRES_USER
          valueFrom:
            secretKeyRef:
              key: database-user
              name: {{ zpshpg_name }}
{% else %}
        - name: POSTGRES_PASSWORD
          value: ""
{% endif %}
        - name: PUBLIC_PROTO
          value: https
        - name: SMTP_HOST
{% if smtp_relay | default(False) %}
          value: {{ smtp_relay }}
        - name: SMTP_PORT
          value: "{{ smtp_port | default('25') }}"
        - name: SMTP_PROTO
          value: smtp
{% elif smtps_address | default(False) %}
          value: {{ smtps_address | urlsplit('hostname') }}
        - name: SMTP_PORT
          value: "{{ smtps_address | urlsplit('port') }}"
        - name: SMTP_PROTO
          value: smtps
{% elif smtp_address | default(False) %}
          value: {{ smtp_address | urlsplit('hostname') }}
        - name: SMTP_PORT
          value: "{{ smtp_address | urlsplit('port') }}"
        - name: SMTP_PROTO
          value: smtp
{% else %}
          value: ""
        - name: SMTP_PORT
          value: ""
        - name: SMTP_PROTO
          value: ""
{% endif %}
        - name: TZ
          value: {{ timezone }}
{% if do_triggers == False or (opsimages | json_query("[?name=='zpush'].short"))[0] == False %}
        image: {{ (opsimages | json_query("[?name=='zpush'].image"))[0] }}
{% endif %}
        imagePullPolicy: {{ pull_policy }}
        livenessProbe:
          failureThreshold: 28
          httpGet:
            path: /version.php
            port: 8080
          initialDelaySeconds: 60
          periodSeconds: 30
          timeoutSeconds: 5
        name: zpush
        ports:
        - containerPort: 8080
        readinessProbe:
          httpGet:
            path: /version.php
            port: 8080
          initialDelaySeconds: 30
          periodSeconds: 15
          timeoutSeconds: 3
        resources:
          limits:
            cpu: "{{ zpush_cpu_limit }}"
            memory: "{{ zpush_memory_limit }}"
          requests:
            cpu: "{{ zpush_cpu_request }}"
            memory: "{{ zpush_memory_request }}"
        securityContext:
          allowPrivilegeEscalation: false
        volumeMounts:
{% if (do_ldap or imaps_address | default(False) or smtps_address | default(False)) and k8s_flavor == 'kubernetes' %}
        - mountPath: /certs
          name: pkiconf
{% endif %}
        - mountPath: /etc/apache2/sites-enabled
          name: temp
          subPath: apache
        - mountPath: /usr/local/share/ca-certificates
          name: temp
          subPath: ca-certificates
        - mountPath: /usr/share/ca-certificates
          name: temp
          subPath: empty
        - mountPath: /var/lib/z-push
{% if zpush_db_type == 'file' %}
          name: data
{% else %}
          name: temp
{% endif %}
          subPath: lib
{% if do_exporters %}
      - args:
{% if do_debugs %}
        - --log.level=debug
{% endif %}
        - --scrape_uri
        - http://stats:8080/server-status
        - --telemetry.address=:9113
{% if do_triggers == False or (opsimages | json_query("[?name=='httpexporter'].short"))[0] == False %}
        image: {{ (opsimages | json_query("[?name=='httpexporter'].image"))[0] }}
{% endif %}
        imagePullPolicy: {{ pull_policy }}
        livenessProbe:
          failureThreshold: 38
          httpGet:
            path: /
            port: 9113
          initialDelaySeconds: 60
          periodSeconds: 30
          timeoutSeconds: 3
        name: exporter
        ports:
        - containerPort: 9113
        resources:
          limits:
            cpu: "{{ exporter_cpu_limit }}"
            memory: "{{ exporter_memory_limit }}"
          requests:
            cpu: "{{ exporter_cpu_request }}"
            memory: "{{ exporter_memory_request }}"
        securityContext:
          allowPrivilegeEscalation: false
      hostAliases:
      - ip: 127.0.0.1
        hostnames:
        - stats
{% endif %}
{% if k8s_resource_nodes_selectors | length > 0 %}
      nodeSelector:
{% for sel in k8s_resource_nodes_selectors %}
        {{ sel.split('=')[0] }}: "{{ sel.split('=')[1] if (sel.split('=') | length > 1) else '' }}"
{% endfor %}
{% endif %}
{% if k8s_flavor == 'kubernetes' or (k8s_flavor == 'openshift' and ocp_major in [ 4, '4' ]) %}
      priorityClassName: opsperator-infra
{% endif %}
{% if do_topology_spread_constraints | default(False) %}
      topologySpreadConstraints:
      - labelSelector:
          matchLabels:
            name: {{ zpush_name }}
        maxSkew: {{ topology_spread_max_skew | default(1) }}
        topologyKey: {{ k8s_affinity_zone_label }}
{% if scheduling_affinity_required %}
        whenUnsatisfiable: DoNotSchedule
{% else %}
        whenUnsatisfiable: ScheduleAnyway
{% endif %}
{% endif %}
      volumes:
{% if zpush_db_type == 'file' %}
      - name: data
        persistentVolumeClaim:
          claimName: {{ zpush_name }}
{% endif %}
{% if (do_ldap or imaps_address | default(False) or smtps_address | default(False)) and k8s_flavor == 'kubernetes' %}
      - name: pkiconf
        projected:
          sources:
{% if do_ldap %}
          - secret:
              items:
              - key: ca.crt
                path: ca.crt
              name: {{ internal_ca_name | default(cr_name) }}-root-ca
{% if directory_tls_provider | default(tls_provider) == 'cert-manager' %}
              name: certmanager-{{ certmanager_ca_name | default(cr_name) }}-root-ca
{% else %}
              name: {{ internal_ca_name | default(cr_name) }}-root-ca
{% endif %}
{% endif %}
{% if imaps_address | default(False) %}
          - secret:
              items:
              - key: ca.crt
                path: imap-ca.crt
              name: {{ internal_ca_name | default(cr_name) }}-root-ca
{% if cyrus_tls_provider | default(tls_provider) == 'cert-manager' %}
              name: certmanager-{{ certmanager_ca_name | default(cr_name) }}-root-ca
{% else %}
              name: {{ internal_ca_name | default(cr_name) }}-root-ca
{% endif %}
{% endif %}
{% if smtps_address | default(False) %}
          - secret:
              items:
              - key: ca.crt
                path: smtp-ca.crt
{% if smtp_tls_provider | default(tls_provider) == 'cert-manager' %}
              name: certmanager-{{ certmanager_ca_name | default(cr_name) }}-root-ca
{% else %}
              name: {{ internal_ca_name | default(cr_name) }}-root-ca
{% endif %}
{% endif %}
{% endif %}
      - emptyDir: {}
        name: temp
{% if do_triggers %}
  triggers:
{% if (opsimages | json_query("[?name=='zpush'].short"))[0] %}
  - type: ImageChange
    imageChangeParams:
      automatic: true
      containerNames:
      - zpush
      from:
        kind: ImageStreamTag
        name: {{ (opsimages | json_query("[?name=='zpush'].short"))[0] }}
        namespace: {{ buildns }}
{% endif %}
{% if do_exporters and (opsimages | json_query("[?name=='httpexporter'].short"))[0] %}
  - type: ImageChange
    imageChangeParams:
      automatic: true
      containerNames:
      - exporter
      from:
        kind: ImageStreamTag
        name: {{ (opsimages | json_query("[?name=='httpexporter'].short"))[0] }}
        namespace: {{ buildns }}
{% endif %}
  - type: ConfigChange
{% endif %}
